/* Pravljenje pointerske liste celih brojeva*/


#include <stdio.h>
#include <alloc.h>

struct stog {
   int glava;
   struct stog *rep;};

#define novi(x)  x=(struct stog *) malloc(sizeof(struct stog))

void lista1(struct stog **p);
void lista2(struct stog **p);
void ispis(struct stog *p);
void ispiskraja(struct stog *p);
void ubaci(struct stog *p);
void brisi(struct stog *p);

main(){
   struct stog *a,*b;
   novi(a);
   printf("\n\nUneti niz brojeva za kraj uneti 0\n");
   lista1(&a);
   printf("Dobijena je lista\n");
   ispis(a);
   printf("\nLista ispisana s kraja je\n");
   ispiskraja(a);
   brisi(a);
   novi(b);
   printf("\nUneti jos jedan niz brojeva za kraj uneti 0\n");
   lista2(&b);
   printf("Dobijena je lista\n");
   ispis(b);
   printf("\nLista ispisana s kraja je\n");
   ispiskraja(b);
   ubaci(b);
   printf("\nLista sada izgleda ovako ");
   ispis(b);
   brisi(b);
}

void lista1(struct stog **p){
   struct stog *rez,*temp;
   int m;
   rez=NULL;
   scanf("%d",&m);
   while(m!=0){
      novi(temp);
      temp->glava=m;
      temp->rep=rez;
      rez=temp;
      scanf("%d",&m);
   }
   *p=rez;
}

void lista2(struct stog **p){
   struct stog *rez,*pos,*temp;
   int m;
   rez=NULL;
   pos=NULL;
   scanf("%d",&m);
   while(m!=0){
	  novi(temp);
	  temp->rep=NULL;
	  temp->glava=m;
      if(rez==NULL) {
         pos=temp;
         rez=temp;
      }
      else {
         pos->rep=temp;
         pos=temp;
	  }
	  scanf("%d",&m);
   }
   *p=rez;
}

void ispis(struct stog *p){
   while (p!=NULL){
      printf("%d  ",p->glava);
      p=p->rep;
   }
}

void ispiskraja(struct stog *p){
   if(p->rep!=NULL) ispiskraja(p->rep);
   printf("%d  ",p->glava);
}

void ubaci(struct stog *p){
   int i,k=1,n;
   struct stog *temp,*pom;
   pom=p;
   printf("\nNa koje mesto treba ubaciti novi clan liste ");
   scanf("%d",&i);
   printf("Koja je vrednost novog elementa ");scanf("%d",&n);
   while(k<i-1 || pom->rep==NULL){
      k++;
      pom=pom->rep;
   }
   novi(temp);
   temp->glava=n;
   temp->rep=pom->rep;
   pom->rep=temp;
}

void brisi(struct stog *p){
   if(p->rep!=NULL) brisi(p->rep);
   free(p);
}



